package edu.ou.cs.moccad_new;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.concurrent.ExecutionException;

import edu.ou.cs.cacheprototypelibrary.core.cache.Cache;
import edu.ou.cs.cacheprototypelibrary.querycache.exception.InvalidPredicateException;
import edu.ou.cs.cacheprototypelibrary.querycache.exception.TrivialPredicateException;
import edu.ou.cs.cacheprototypelibrary.querycache.query.Predicate;
import edu.ou.cs.cacheprototypelibrary.querycache.query.Query;
import edu.ou.cs.cacheprototypelibrary.querycache.query.QuerySegment;
import edu.ou.cs.cacheprototypelibrary.querycache.query.XopYPredicate;

public class Query_Builder_New extends AppCompatActivity {
    String IP;
    ArrayList<String> fields;
    Button executeQuery;
    EditText queryCondition;
    Query q;
    String[] opCodes = {"<","<=","=",">=",">"};
    ArrayList<String> columns;

    ListView lView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_query__builder__new);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        System.out.println("In QueryBuilder constructor");

        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            this.IP = extras.getString("IPAddress");
            Log.i("QueryBuilder", "Got IPAddress " + this.IP + " as extra data.");
        } else {
            return;
            //Probably need an error message in here.
        }

        try {
            BackgroundTask task = new BackgroundTask();
            task.getDBInfo = true;
            //String str_result = task.execute().get(); //Call to doInBackground
            task.execute().get();
        } catch (InterruptedException | ExecutionException e) {
            e.printStackTrace();
        }

        final Spinner dropdown = (Spinner) findViewById(R.id.spinner);
        String[] items = new String[fields.size()];
        fields.toArray(items);
        ArrayAdapter<String> adapter = new ArrayAdapter<>(this, android.R.layout.simple_spinner_dropdown_item, items);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        if (dropdown != null) {
            dropdown.setAdapter(adapter);
        }

        lView = (ListView) findViewById(R.id.predicateList);

        // Fetch columns if the selection changes on the spinner.
        if (dropdown != null) {
            dropdown.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                @Override
                public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                    System.out.println("SOMETHING SELECTED IN THE SPINNER");
                    String check = "WOOHOO   " + dropdown.getSelectedItem();
                    Toast.makeText(Query_Builder_New.this, check, Toast.LENGTH_SHORT).show();

                    BackgroundTask task = new BackgroundTask();
                    task.getColumns = true;
                    task.tableName = (String) dropdown.getSelectedItem();
                    try {
                        task.execute().get();
                    } catch (InterruptedException | ExecutionException e) {
                        e.printStackTrace();
                    }
                }

                @Override
                public void onNothingSelected(AdapterView<?> parent) {
                    System.out.println("NOTHING SELECTED IN THE SPINNER");
                }
            });
        }

        final Spinner dropdown2 = (Spinner) findViewById(R.id.spinner2);
        ArrayAdapter<String> adapter2 = new ArrayAdapter<>(this, android.R.layout.simple_spinner_dropdown_item, items);
        adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        if (dropdown2 != null) {
            dropdown2.setAdapter(adapter2);
        }

        // Not sure why the line immediately below was there. Commented out - Akshay.
        //MOCCAD mApplication = (MOCCAD)getApplicationContext();
        if (((MOCCAD) this.getApplication()).getQueryCache() == null) {
            System.out.println("Creating cache");
            ((MOCCAD) this.getApplication()).setCacheManager();
            //XXX: I'm not sure what happens here if the user has selected "No Cache" from the settings menu...
        }
        final Cache<Query, QuerySegment> cache = ((MOCCAD) this.getApplication()).getQueryCache();

        queryCondition = (EditText) findViewById(R.id.queryCondition);
        executeQuery = (Button) findViewById(R.id.executeQuery);
        executeQuery.setOnClickListener(
                new View.OnClickListener() {
                    public void onClick(View view) {
                        String selectField = null;

                        EditText constnt_field = (EditText) lView.findViewById(R.id.post_attr);
                        String constant = constnt_field.getText().toString();

                        System.out.println("THe entry is  " + constant);

                        if (dropdown != null) {
                            selectField = (String) dropdown.getSelectedItem();
                        }
/*                        String fromTable = selectField.substring(0, selectField.indexOf('.'));
                            selectField = selectField.substring(selectField.indexOf('.') + 1);*/
                        String conditionField = null;
                        if (dropdown2 != null) {
                            conditionField = (String) dropdown2.getSelectedItem();
                        }
                        String condition = queryCondition.getText().toString();
                        String fromTable = (String)dropdown.getSelectedItem();

                        //String QUERY = "SELECT " + selectField + " FROM " + fromTable + " WHERE " + conditionField;
                        //String QUERY = "SELECT TOP 5 * FROM " + fromTable + " WHERE " + conditionField;
                        String QUERY = "SELECT * FROM " + fromTable + " LIMIT 5"; // + " WHERE " + conditionField;
                        if (isConditionText(condition))
                            QUERY += " = \"" + condition + "\""; //Adds quotation marks for string literals.
                        //else
                        //    QUERY += " = " + condition; //No quotation marks for numeric fields

                        q = new Query(selectField);
                        try {
                            q.addPredicate(new XopYPredicate(conditionField, "=", condition));
                        } catch (InvalidPredicateException | TrivialPredicateException e) {
                            e.printStackTrace();
                        }
                        QuerySegment qs = new QuerySegment();

                        BackgroundTask task = new BackgroundTask();
                        task.getDBInfo = true;
                        String cachedResults = null;

                        try {
                            if (cache.containsKey(q)) {
                                //System.out.println("Running query from cache.");

                                Log.i("QueryBuilder", "Running query from cache.");

                                String template = "{\"server_response\":[{\"Field\":\"%s\"}]}";
                                List<List<String>> tuples;
                                tuples = cache.getCacheContentManager().get(q).getTuples();

                                System.out.println("TUPLES:");
                                for (List<String> tuple : tuples) {
                                    for (String fieldValue : tuple) {
                                        System.out.println(fieldValue);
                                        cachedResults = String.format(template, fieldValue);

                                    }
                                }
                            } else {
                                cache.add(q, qs.filter(q));
                            }

                            BackgroundTask runQuery = new BackgroundTask();
                            runQuery.getDBInfo = false;
                            runQuery.query = QUERY;
                            runQuery.cachedResults = cachedResults;
                            runQuery.execute().get(); //Call to doInBackground
                        } catch (InterruptedException | ExecutionException e) {
                            e.printStackTrace();
                        }
                    }
                });
    }

    class BackgroundTask extends AsyncTask<Void, Void, String> {
        boolean getDBInfo = false;
        boolean getColumns = false;
        String query = null;
        String cachedResults = null;
        String tableName;

        @Override
        protected String doInBackground(Void... params) {
            String tempString;
            try {
                String server = "http://" + IP + "/";
                URL url;
                if (this.getDBInfo) {
                    url = new URL(server + "getDBInfo.php");
                } else if (this.getColumns) {
                    url = new URL(server + "getColumns.php?tableName=" + this.tableName);
                } else if (this.cachedResults != null) {
                    return cachedResults.trim();
                } else {
                    if (query != null) {
                        String encodedURL = URLEncoder.encode(query, "UTF-8");
                        int timeParam = ((MOCCAD) getApplication()).getTime();
                        int moneyParam = ((MOCCAD) getApplication()).getMoney();
                        int powerParam = ((MOCCAD) getApplication()).getPower();
                        url = new URL(server + "create_json.php?query=" + encodedURL +
                                "&time=" + timeParam + "&money=" + moneyParam + "&power=" + powerParam);
                    } else
                        return "Error: Query is null.";
                }
                HttpURLConnection httpURLConnection = (HttpURLConnection) url.openConnection();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferedReader = new BufferedReader(
                        new InputStreamReader(
                                inputStream));
                StringBuilder stringBuilder = new StringBuilder();
                while ((tempString = bufferedReader.readLine()) != null) {
                    stringBuilder.append(tempString).append("\n");
                }

                bufferedReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                if (this.getDBInfo) {
                    buildList(stringBuilder.toString().trim());
                    return null;
                }
                if (this.getColumns) {
                    decodeColumns(stringBuilder.toString().trim());
                    return null;
                }
                return stringBuilder.toString().trim();
            } catch (MalformedURLException e) {
                System.out.println("Threw MalformedURLException");
                e.printStackTrace();
            } catch (IOException e) {
                System.out.println("Threw IOException");
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String result) {
            if (result != null) {
                Intent intent = new Intent(getApplicationContext(), QueryResults.class);
                intent.putExtra("json_string", result);
                intent.putExtra("queryRelation", q.getRelation());
                Set<Predicate> preds = q.getPredicates();
                Iterator<Predicate> predicateIterator = preds.iterator();
                if (predicateIterator.hasNext())
                    intent.putExtra("queryPredicate", predicateIterator.next().toString());
                else
                    intent.putExtra("queryPredicate", "");
                startActivity(intent);
            }
        }

        protected void buildList(String result) {
            if (result == null) {
                return;
                //Probably need an error message here.
            }

            try {
                System.out.println("JSON String: " + result);
                JSONObject jsonObject = new JSONObject(result);
                System.out.println("After new JSONObject.");
                JSONArray jsonArray = jsonObject.getJSONArray("server_response");
                int count = 0;
                String table;
                fields = new ArrayList<>();

                while (count < jsonArray.length()) {
                    JSONObject jo = jsonArray.getJSONObject(count);
                    table = jo.getString("TABLE_NAME");
                    fields.add(table);

                    count++;
                }

            } catch (JSONException e) {
                e.printStackTrace();
            }
        }

        private void decodeColumns(String columnsJson) {
            if (columnsJson == null) {
                return;
                //Probably need an error message here.
            }

            try {
                System.out.println("JSON String: " + columnsJson);
                JSONObject jsonObject = new JSONObject(columnsJson);
                System.out.println("After new JSONObject.");
                JSONArray jsonArray = jsonObject.getJSONArray("server_response");
                int count = 0;
                String column;
                columns = new ArrayList<>();

                while (count < jsonArray.length()) {
                    JSONObject jo = jsonArray.getJSONObject(count);
                    column = jo.getString("COLUMN_NAME");
                    columns.add(column);
                    count++;
                }

            } catch (JSONException e) {
                e.printStackTrace();
            }

        }
    }

    boolean isConditionText(String condition) {
        for (char c : condition.toCharArray()) {
            if (Character.isLetter(c))
                return true; //Return true if the condition contains a single letter.
        }
        return false;
    }


    public void addPredicate(View v) {
        final CharSequence[] queryOption = {"Attribute vs.Attribute", "Attribute vs. Constant"};
        AlertDialog.Builder alert = new AlertDialog.Builder(this)
                .setTitle("Pick predicate type.")
                .setSingleChoiceItems(queryOption, -1, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        System.out.println("Selected Item  " + queryOption[which]);
                        ((AlertDialog) dialog).getButton(DialogInterface.BUTTON_POSITIVE).setEnabled(true);
                    }
                })
                .setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        ListView list = ((AlertDialog) dialog).getListView();
                        Object checkedItem = list.getAdapter().getItem(list.getCheckedItemPosition());
                        System.out.println("Checked item  " + checkedItem);
                        if (checkedItem.equals("Attribute vs.Attribute")) {
                            System.out.println("A VS A");
                            addAVsA();
                        } else {
                            System.out.println("A VS C");
                            addAVsC();
                        }
                    }
                })
                .setNegativeButton(android.R.string.cancel, null);

        AlertDialog alert1 = alert.create();
        alert1.show();
        alert1.getButton(DialogInterface.BUTTON_POSITIVE).setEnabled(false);
        //Toast.makeText(this, "Button1 clicked.", Toast.LENGTH_SHORT).show();

    }

    private void addAVsA() {
        PredicateAdapter adapter = new PredicateAdapter();
        adapter.addType1("item 1");
        //ListView lView = (ListView) findViewById(R.id.predicateList);
        if (lView != null) {
            lView.setAdapter(adapter);
        }
    }

    private void addAVsC() {
        PredicateAdapter adapter = new PredicateAdapter();
        adapter.addItem("item 2");
        //ListView lView = (ListView) findViewById(R.id.predicateList);
        if (lView != null) {
            lView.setAdapter(adapter);
        }
    }

    public class PredicateAdapter extends BaseAdapter {

        private static final int LAYOUT_0 = 0;
        private static final int LAYOUT_1 = 1;
        private static final int MAX_LAYOUT_COUNT = 2;

        // Type1 is the attribute vs attribute type.
        private TreeSet<Integer> mType1 = new TreeSet<Integer>();

        private LayoutInflater mInflator;
        private ArrayList mData = new ArrayList();

        public PredicateAdapter() {
            mInflator = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        }

        public void addItem(final String item) {
            mData.add(item);
            notifyDataSetChanged();
        }

        public void addType1(final String item) {
            mData.add(item);
            // save type1 position
            mType1.add(mData.size() - 1);
            notifyDataSetChanged();
        }

        @Override
        public int getItemViewType(int position) {
            return mType1.contains(position) ? LAYOUT_0 : LAYOUT_1;
        }

        @Override
        public int getViewTypeCount() {
            return MAX_LAYOUT_COUNT;
        }

        @Override
        public int getCount() {
            return mData.size();
        }

        @Override
        public Object getItem(int position) {
            return mData.get(position);
        }

        @Override
        public long getItemId(int position) {
            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            ViewHolder holder;
            int type = getItemViewType(position);
            System.out.println("getView " + position + " " + convertView + " type = " + type);
            if (convertView == null) {
                holder = new ViewHolder();
                switch (type) {
                    case LAYOUT_0:
                        convertView = mInflator.inflate(R.layout.a_vs_a, null);
                        holder.spinner1 = (Spinner) convertView.findViewById(R.id.pre_attr);
                        ArrayAdapter<String> adapter1a = new ArrayAdapter<String>(Query_Builder_New.this, android.R.layout.simple_spinner_dropdown_item, columns);
                        adapter1a.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                        if (holder.spinner1 != null) {
                            holder.spinner1.setAdapter(adapter1a);
                        }
                        holder.spinner2 = (Spinner) convertView.findViewById(R.id.op);
                        ArrayAdapter<String> adapter2a = new ArrayAdapter<String>(Query_Builder_New.this, android.R.layout.simple_spinner_dropdown_item, opCodes);
                        adapter2a.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                        if (holder.spinner2 != null) {
                            holder.spinner2.setAdapter(adapter2a);
                        }
                        holder.spinner3 = (Spinner) convertView.findViewById(R.id.post_attr);
                        ArrayAdapter<String> adapter3 = new ArrayAdapter<String>(Query_Builder_New.this, android.R.layout.simple_spinner_dropdown_item, columns);
                        adapter3.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                        if (holder.spinner3 != null) {
                            holder.spinner3.setAdapter(adapter3);
                        }
                        break;
                    case LAYOUT_1:
                        convertView = mInflator.inflate(R.layout.a_vs_c, null);
                        holder.spinner1 = (Spinner) convertView.findViewById(R.id.pre_attr);
                        ArrayAdapter<String> adapter1b = new ArrayAdapter<String>(Query_Builder_New.this, android.R.layout.simple_spinner_dropdown_item, columns);
                        adapter1b.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                        if (holder.spinner1 != null) {
                            holder.spinner1.setAdapter(adapter1b);
                        }
                        holder.spinner2 = (Spinner) convertView.findViewById(R.id.op);
                        ArrayAdapter<String> adapter2b = new ArrayAdapter<String>(Query_Builder_New.this, android.R.layout.simple_spinner_dropdown_item, opCodes);
                        adapter2b.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                        if (holder.spinner2 != null) {
                            holder.spinner2.setAdapter(adapter2b);
                        }
                        holder.editText = (EditText) convertView.findViewById(R.id.post_attr);
                        break;
                }
                convertView.setTag(holder);
            } else {
                holder = (ViewHolder) convertView.getTag();
            }
            return convertView;
        }
    }

    public class ViewHolder {
        public Spinner spinner1;
        public Spinner spinner2;
        public Spinner spinner3;
        public EditText editText;

    }
}